﻿using System;
using System.Windows.Forms;

namespace LAB9
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //globális változók helye


        //metódusok helye

        /// <summary>
        /// Két double típusú szám összege
        /// </summary>
        /// <param name="a">első szám</param>
        /// <param name="b">második szám</param>
        /// <returns>A két szám összege</returns>
        double osszeg(double a, double b)
        {
            double c = a + b;
            return c;  //return kötelező, visszaadja az eredményt
        }

        //túlterhelés (ugyanazzal a névvel, de más argumentumokkal)
        int osszeg(int a, int b)
        {
            return a + b;
        }

        // Ha nincs visszatérése, akkor void, nincs return
        void Kiir(string szoveg)
        {
            listBox1.Items.Add(szoveg);
            label1.Text += szoveg + "\r\n";
        }

        // nincs argumentum
        void Torles()
        {
            listBox1.Items.Clear();
            label1.Text = "";
        }

        // kimeneti változó out használata
        // kötelező értéket adni neki a metóduson belül
        void osszeg(int a, int b, out int c)
        {
            c = a + b;
        }

        // referencia használata
        // ref visszahat az átadott változóra
        void osszeg(double a, double b, ref double c)
        {
            c = a + b;
        }

        // két változó megcserélése, referencia kell
        void csere(ref int a, ref int b)
        {
            int tmp = a;
            a = b;
            b = tmp;
        }

        //Kapcsos függvény
        // sin(x)  -    x < -1
        //  x^2    -    -1 <= x < 1
        // ln(x)   -    x >= 1 
        double fgv(double x)
        {
            double y;

            if (x < -1) y = Math.Sin(x);
            else if (x >= 1) y = Math.Log(x);
            else y = x * x;

            return y;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Text = "Függvény";
            button1.Text = "Függvények";
            Random randi = new Random();
            randi.Next();
            label1.Text = "";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // argumentum nélküli metódus
            Torles();

            double elso = 3.14, masodik = 6.28;
            // metódus két szám összeadására
            double eredmeny = osszeg(elso, masodik);
            // metódus kiíratáshoz
            Kiir(eredmeny.ToString());
            eredmeny = osszeg(elso, 5);
            Kiir(eredmeny.ToString());
            int eredmeny2 = Convert.ToInt32(osszeg(elso, 3));
            Kiir(eredmeny2.ToString());

            // out használata
            int alma = 5, korte = 3, gyumolcs; //gyumolcs-nek nem kötelező kezdőérték 
            osszeg(alma, korte, out gyumolcs);  //gyumolcs értéket fog kapni
            Kiir(gyumolcs.ToString());

            // ref használta
            double harmadik = 0; // kötelező értéknek lennie
            osszeg(elso, masodik, ref harmadik); //harmadik értéke megváltozhat
            Kiir(harmadik.ToString());

            // a cseréhez referencia átadása szükséges
            csere(ref alma, ref korte);
            Kiir(alma.ToString());

            // Függvény hívása különböző értékekkel
            Kiir(fgv(-1.5).ToString());
            Kiir(fgv(0.5).ToString());
            Kiir(fgv(+1.5).ToString());

        }
    }
}
